/*
 * ---------------------------------------------------------------------------
 * This file declares constants, functions, ... used to control/interpret the
 * pressed buttons at the matrix button field.
 * author : Mstl Georg
 * date   : 16.11.2006
 * ---------------------------------------------------------------------------
 */
 
 
 #include <stdint.h>
 
 
 #ifndef __KEYPAD_CTRL__
	#define ___KEYPAD_CTRL__
	
	/* 
	 * -------------------------------------------------------------------------
	 * general constant declarations 
	 * -------------------------------------------------------------------------
	 */
	
  //mapping between internal used button code (0 - 11) and external expected
	//button value (0 - 9, *, #)
	#define	BUT_0				10
	#define	BUT_1				0
	#define	BUT_2				1
	#define	BUT_3				2
	#define	BUT_4				3
	#define	BUT_5				4
	#define	BUT_6				5
	#define	BUT_7				6
	#define	BUT_8				7
	#define	BUT_9				8
	#define	BUT_MULT		9		//'*'
	#define	BUT_FENCE		11	//'#'
	#define NO_KEY      255 //no key was pressed
	
	#define SAMPLE_TIME 	100 //sample time of key
	 
	 
	/* 
	 * -------------------------------------------------------------------------
	 * general function declarations 
	 * -------------------------------------------------------------------------
	 */
 
  uint8_t readKeypadKEY(volatile uint8_t* port, volatile uint8_t* pin);
	
	void waitReleasedKEY(uint8_t button);
	
	void waitNoKEY(void);
	
	uint8_t detKeyValKEY(uint8_t key);
	
	void initKEY(void);
	
#endif
