/*
 * ---------------------------------------------------------------------------
 * This file declares constants, functions, ... used to control the lcd.
 * author : Mstl Georg
 * date   : 14.11.2006
 * ---------------------------------------------------------------------------
 */
 
#include <stdint.h>

 
#ifndef __LCD_CTRL__
	#define __LCD_CRTRL__
	
	/* 
	 * -------------------------------------------------------------------------
	 * general constant declarations 
	 * -------------------------------------------------------------------------
	 */
	 
	//time parameters
	//#define	MIN_TIME_PWR_ON_LCD			 50	  //min. time after pwr on reset [ms]
	//#define MIN_PULSE_WIDTH_EN_LCD 	 0.5  //min. pulse width of en signal [us]
	//#define MIN_TIME_FIRST_BYTE_LCD  5    //min. time after first sent byte [ms]
	//#define MIN_TIME_BETW_BYTE_LCD	 0.1	//min. time between two 4 bit nibbles
																		  	//[ms]
																				
	#define	MIN_TIME_PWR_ON_LCD			 5000	  //min. time after pwr on reset [ms]
	#define MIN_PULSE_WIDTH_EN_LCD 	 50  //min. pulse width of en signal [us]
	#define MIN_TIME_FIRST_BYTE_LCD  500    //min. time after first sent byte [ms]
	#define MIN_TIME_BETW_BYTE_LCD	 10	//min. time between two 4 bit nibbles
																		  	//[ms]
	
	
	//busy flag
	#define BUSY_FLAG_POS_LCD       7    //position of busy flag in 
	                                     //"Busy Flag/Address Read" cmd
	
	//display layout
	#define MAX_NR_LINES_LCD				4    //max. nr of available lines in lcd
	#define MAX_LINE_LENGTH_LCD			20   //max. nr of available char in one line
	
	#define FIRST_LINE_START_LCD		0x00 //first line  : 0x00 - 0x13
	#define SECOND_LINE_START_LCD		0x40 //second line : 0x40 - 0x53
	#define THIRD_LINE_START_LCD	  0x14 //third line  : 0x14 - 0x27
	#define FOURTH_LINE_START_LCD   0x54 //fourth line : 0x54 - 0x67
	
	//codes of special characters
	#define LEFT_ARROW_STR_LCD			"\x7F" //"<-"
	#define RIGHT_ARROW_STR_LCD	    "\x7E" //"->"
	#define LEFT_ARROW_CHAR_LCD     0x7F
	#define RIGHT_ARROW_CHAR_LCD    0x7E
	
	//special cmd
	#define CLEAR_DISPLAY		0x01
	#define CURSOR_AT_HOME	0x02
	#define DDR_ADR_SET     0x80
	
	
  /* 
	 * -------------------------------------------------------------------------
	 * general function declarations 
	 * -------------------------------------------------------------------------
	 */
	
	void sendSignPosLCD(uint8_t sign, uint8_t pos);
	
	void sendTextPosLCD(char* text, uint8_t pos);
	
	void clearLCD(void);
	
	void initLCD(void);
	
		
#endif	
